/* This is the main window for our precision test.
 * It inherits from the QMainDialog class.
 * 
 * author: Lukas Novosad - novosluk@fel.cvut.cz
 * date: 28/9/2010
 * modifications" Petr Felkel - felkel@fel.cvut.cz
 * date: 28.10.2012
 *   additional data types and setup for generation script
 *
 */

#include "exercise_1.h"
#include <Qt\qlabel.h>

// ======== BEGIN OF SOLUTION - TASK 1-1 ======== //
// include necessary headers for data types used 
// ========  END OF SOLUTION - TASK 1-1  ======== //

exercise_1::exercise_1(QWidget *parent, Qt::WFlags flags)
    : QMainWindow(parent, flags)
{
    ui.setupUi(this);

    currentDataTypeLabel = new QLabel(tr(""));
    ui.statusBar->insertWidget(1, currentDataTypeLabel);

    QLabel * permanentLabel = new QLabel;
    permanentLabel->setText(tr("Select Type & Precision"));
    ui.statusBar->insertPermanentWidget(2, permanentLabel);

    // start with doubles
    setPrecisionCD();  
    //setExponent(-53);
    centralWidget.setEpsilonExponent(-53);
    centralWidget.setParent(this);

    // sets the central widget for the Qt main window
    // in our case this is the widget which draws the precision test
    setCentralWidget(&centralWidget);

    // Qt connect statements
    QObject::connect(this, SIGNAL(epsilonExponentChanged(int)), &centralWidget, SLOT(setEpsilonExponent(int)));
    QObject::connect(this, SIGNAL(precisionChanged(Precision)), &centralWidget, SLOT(setPrecision(Precision)));

}

exercise_1::~exercise_1()
{

}

void exercise_1::createAboutDialog()
{
    aboutDialog.setModal(true);
    aboutDialog.show();
}

void exercise_1::createEpsilonDialog()
{
    bool ok;
    int value;

    value = QInputDialog::getInteger(this,
                                     tr("Epsilon value"),
                                     tr("Set the exponent to be used for the epsilon value.\n"
                                     "The base is 2."),
                                     //centralWidget.getEpsilonExponent(), -126, +127, 1, &ok);
                                     centralWidget.getEpsilonExponent(), -300, +300, 1, &ok);

    if(ok)
    {
        
        emit epsilonExponentChanged(value);
    }
    
}

void exercise_1::setExponent(int value)
{
  emit epsilonExponentChanged(value);
}

void exercise_1::setPrecisionCF()
{
  currentDataTypeLabel->setText(tr("Data type set to CF"));
  emit precisionChanged(CF);
}

void exercise_1::setPrecisionCD()
{
  currentDataTypeLabel->setText(tr("Data type set to CD"));
  emit precisionChanged(CD);
}

//TODO: implement the additional signals defined via the Qt Designer
// ======== BEGIN OF SOLUTION - TASK 1-2 ======== //
// ========  END OF SOLUTION - TASK 1-2  ======== //
